local fonttable = {}
local linetable = {}
local bigtable = {}
local scrolltable = {}
local mw_count = 0	
local playername = nil
local incoming = true
local outgoing = true
local outgoingMisses = true
local outgoingHeals = true
local outgoingDmg = true
local incomingMisses = true
local incomingHeals = true
local incomingDmg = true
local shown = true
local number = 1
local lock = false
	

-- Register our addon with ace
WJH = LibStub("AceAddon-3.0"):NewAddon("WJH", "AceConsole-3.0", "AceEvent-3.0")
AceGUI = LibStub("AceGUI-3.0")

function WJH:OnEnable() -- register events to start addon functions
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("PLAYER_LOGOUT")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function WJH:PLAYER_ENTERING_WORLD()

	if WJH_Saved ~= nil then
		incoming = WJH_Saved['incoming']
		outgoing = WJH_Saved['outgoing']
		outgoingMisses = WJH_Saved['outgoingMisses']
		outgoingHeals = WJH_Saved['outgoingHeals']
		outgoingDmg = WJH_Saved['outgoingDmg']
		incomingMisses = WJH_Saved['incomingMisses']
		incomingHeals = WJH_Saved['incomingHeals']
		incomingDmg = WJH_Saved['incomingDmg']
		if WJH_Saved['lock'] ~= nil then
			lock = WJH_Saved['lock']
		end
		if WJH_Saved['shown'] ~= nil then
			shown = WJH_Saved['shown']
		end
		if WJH_Saved['shown'] ~= nil then
			number = WJH_Saved['number']
		end
		
		incomingCheckButton:SetChecked(incoming)
		outgoingCheckButton:SetChecked(outgoing)
		outgoingmissesbox:SetChecked(outgoingMisses)
		outgoinghealsbox:SetChecked(outgoingHeals)
		outgoingdamagebox:SetChecked(outgoingDmg)
		incomingmissesbox:SetChecked(incomingMisses)
		incominghealsbox:SetChecked(incomingHeals)
		incomingdamagebox:SetChecked(incomingDmg)
		WJH_MainFrame:SetScale(number)
		if lock == true then
			WJH_MainFrame:EnableMouse(false)
		end
		if WJH_Saved['shown'] == true then
			WJH_MainFrame:Show()
		else
			WJH_MainFrame:Hide()
		end
	end
end

function WJH:PLAYER_LOGOUT()
	if WJH_Saved == nil then
		WJH_Saved = {}
	end
	WJH_Saved['incoming'] = incoming
	WJH_Saved['outgoing'] = outgoing
	WJH_Saved['outgiongMisses'] = outgoingMisses
	WJH_Saved['outgoingHeals'] = outgoingHeals
	WJH_Saved['outgoingDmg'] = outgoingDmg
	WJH_Saved['incomingMisses'] = incomingMisses
	WJH_Saved['incomingHeals'] = incomingHeals
	WJH_Saved['incomingDmg'] = incomingDmg
	WJH_Saved['number'] = number
	WJH_Saved['lock'] = lock
	if WJH_MainFrame:IsShown() == 1 then
		WJH_Saved['shown'] = true
	else
		WJH_Saved['shown'] = false
	end
end

function WJH:OnDisable()  -- unregisters events to stop most addon functions
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function WJH:Reset()  -- currently unused, will be used to reset options and clear stuff
end

function WJH:OnInitialize()  -- ace calls when addon is initialized, put stuff here that needs to happen before anything else
	-- CreateFrame('MESSAGEFRAME', 'WJH_Frame', UIParent) -- placeholder for main frame, maybe I should use acegui instead ?
	-- WJH_Frame:SetHeight(100)
	-- WJH_Frame:SetWidth(500)
	-- WJH_Frame:ClearAllPoints()
	-- WJH_Frame:SetPoint('RIGHT', UIParent, 'CENTER', 0, -100)
	-- WJH_Frame:SetJustifyH('LEFT')
	-- WJH_Frame:SetFont("Fonts\\FRIZQT__.TTF", 11)
	-- WJH_Frame:SetInsertMode('BOTTOM')
	self:RegisterChatCommand("WJH", "ChatCommand")
	playername,_ = UnitName('player')
	WJH_Constructor()
	WJH_MainFrame:Hide()
end
	
function WJH_Constructor()
	local FrameBackdrop = {
		bgFile="Interface\\AddOns\\WJH\Textures\\UI-DialogBox-Background",
		edgeFile="Interface\\AddOns\\WJH\\Textures\\UI-DialogBox-Border", 
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 8, right = 8, top = 8, bottom = 8 }
	}
	local PaneBackdrop  = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\AddOns\\WJH\\Textures\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 5, bottom = 3 }
	}
		
	local frame = CreateFrame("Frame","WJH_MainFrame",UIParent)
	local self = {}
	
	local function WJH_IncomingButton()
		incomingCheckButton:Hide()
		outgoingCheckButton:Hide()
		outgoingbutton:Hide()
		incomingbutton:Hide()
		
		incomingmissesbox:Show()
		incomingmissesfont:Show()
		incominghealsbox:Show()
		incominghealsfont:Show()
		incomingdamagebox:Show()
		incomingdamagefont:Show()
		
		WJH_Clear:Hide()
		
		WJH_backbutton:Show()
	end

	local function WJH_OutgoingButton()
		incomingCheckButton:Hide()
		outgoingCheckButton:Hide()
		outgoingbutton:Hide()
		incomingbutton:Hide()
		
		outgoingmissesbox:Show()
		outgoingmissesfont:Show()
		outgoinghealsbox:Show()
		outgoinghealsfont:Show()
		outgoingdamagebox:Show()
		outgoingdamagefont:Show()
		
		WJH_Clear:Hide()
		
		WJH_backbutton:Show()
	end
	
	local function WJH_BackButton()
		outgoingmissesbox:Hide()
		outgoingmissesfont:Hide()
		outgoinghealsbox:Hide()
		outgoinghealsfont:Hide()
		outgoingdamagebox:Hide()
		outgoingdamagefont:Hide()
		
		incomingmissesbox:Hide()
		incomingmissesfont:Hide()
		incominghealsbox:Hide()
		incominghealsfont:Hide()
		incomingdamagebox:Hide()
		incomingdamagefont:Hide()
		
		incomingCheckButton:Show()
		outgoingCheckButton:Show()
		outgoingbutton:Show()
		incomingbutton:Show()
		
		WJH_Clear:Show()
		
		WJH_backbutton:Hide()
	end
	
	function closeOnClick(this)
		frame:Hide()
	end
	
	function titleOnMouseDown(this)
		this:StartMoving()
	end
	
	function frameOnMouseUp(this)
		-- local frame = this:GetParent()
		WJH_MainFrame:StopMovingOrSizing()
	end
	
	function sizerseOnMouseDown(this)
		this:GetParent():StartSizing("BOTTOMRIGHT")
	end
	
	function sizersOnMouseDown(this)
		this:GetParent():StartSizing("BOTTOM")
	end
	
	function sizereOnMouseDown(this)
		this:GetParent():StartSizing("RIGHT")
	end

	function SetTitle(self,title)
		self.titletext:SetText(title)
	end
	
	function SetStatusText(self,text)
		self.statustext:SetText(text)
	end
	
	function Hide(self)
		self.frame:Hide()
	end
	
	function Show(self)
		self.frame:Show()
	end
	
	frame:SetWidth(240)
	frame:SetHeight(165)
	frame:SetPoint("CENTER",UIParent,"CENTER",0,0)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetResizable(true)
	frame:SetFrameStrata("FULLSCREEN_DIALOG")
	frame:SetScript("OnMouseDown", frameOnMouseDown)
	
	frame:SetBackdrop(PaneBackdrop)
	frame:SetBackdropColor(0,0,0,0.8)
	frame:SetScript("OnHide",frameOnClose)
	frame:SetMinResize(200,100)
	frame:SetMaxResize(241, 165)
	frame:SetToplevel(true)
	
	-- local leftframe = CreateFrame("Frame",nil,frame)
	-- leftframe:SetBackdrop(FrameBackdrop)
	-- leftframe:SetBackdropColor(0,0,0,0.8)
	-- leftframe:ClearAllPoints()
	-- leftframe:SetPoint('TOPLEFT', frame, 'TOPLEFT', 10, -10)
	-- leftframe:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMLEFT', (((frame:GetWidth()/4))+5), 33)
	
	local rightframe = CreateFrame("Frame", WJH_Rightframe, frame)
	rightframe:SetBackdrop(FrameBackdrop)
	rightframe:SetBackdropColor(0.05,0.05,0.05,  0)
	rightframe:ClearAllPoints()
	rightframe:SetPoint('TOPLEFT', frame, 'TOPLEFT', -6, 6 )
	rightframe:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 6, 17)
	
	local mousescrollframe = CreateFrame("Frame", "WJH_MouseFrame", frame)
	-- mousescrollframe:EnableMouse()
	mousescrollframe:SetAllPoints(rightframe)
	mousescrollframe:SetScript("OnMouseWheel", WJH_OnMouseWheel)
	mousescrollframe:SetFrameLevel(10)
	mousescrollframe:EnableMouseWheel(true)
	
	local closebutton = CreateFrame("Button",nil,frame,"UIPanelButtonTemplate")
	closebutton:SetScript("OnClick", closeOnClick)
	closebutton:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-14,8)
	closebutton:SetHeight(20)
	closebutton:SetWidth(20)
	closebutton:SetText('X')
	closebutton:SetNormalTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Up")
	closebutton:SetPushedTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Down")
	closebutton:SetHighlightTexture("Interface\\AddOns\\WJH\\Textures\\ButtonHilight-Square")
	
	local clearbutton = CreateFrame("Button","WJH_Clear",frame,"UIPanelButtonTemplate")
	clearbutton:SetScript("OnClick", function() print(#bigtable..'entries cleared') wipe(bigtable) WJH:Refresh() end)
	clearbutton:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-130,10)
	clearbutton:SetHeight(14)
	clearbutton:SetWidth(14)
	clearbutton:SetText('-')
	clearbutton:SetNormalTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Up")
	clearbutton:SetPushedTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Down")
	clearbutton:SetHighlightTexture("Interface\\AddOns\\WJH\\Textures\\ButtonHilight-Square")
	
	local WJH_backbutton = CreateFrame("Button", "WJH_backbutton", frame,"UIPanelButtonTemplate")
	WJH_backbutton:SetScript("OnClick", WJH_BackButton)
	WJH_backbutton:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -50, 10)
	WJH_backbutton:SetHeight(14)
	WJH_backbutton:SetWidth(14)
	WJH_backbutton:SetText('<-')
	WJH_backbutton:Hide()
	WJH_backbutton:SetNormalTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Up")
	WJH_backbutton:SetPushedTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Down")
	WJH_backbutton:SetHighlightTexture("Interface\\AddOns\\WJH\\Textures\\ButtonHilight-Square")
	
	local incomingbutton = CreateFrame("Button","incomingbutton",frame,"UIPanelButtonTemplate")
	incomingbutton:SetScript("OnClick", WJH_IncomingButton)
	incomingbutton:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",37,10)
	incomingbutton:SetHeight(14)
	incomingbutton:SetWidth(18)
	incomingbutton:SetText('|cffcc0000<--')
	incomingbutton:SetNormalTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Up")
	incomingbutton:SetPushedTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Down")
	incomingbutton:SetHighlightTexture("Interface\\AddOns\\WJH\\Textures\\ButtonHilight-Square")
	
	local incomingfont = incomingbutton:CreateFontString("WJH_incomingfont","OVERLAY","GameFontNormal")
	incomingfont:SetJustifyH("LEFT")
	incomingfont:SetPoint("TOPLEFT", incomingbutton, "TOPRIGHT", 7, 0)
	incomingfont:SetText("In")
	incomingfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	incomingfont:Show()
	
	local outgoingbutton = CreateFrame("Button","outgoingbutton",frame,"UIPanelButtonTemplate")
	outgoingbutton:SetScript("OnClick", WJH_OutgoingButton)
	outgoingbutton:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-75,10)
	outgoingbutton:SetHeight(14)
	outgoingbutton:SetWidth(18)
	outgoingbutton:SetText('|cff00FF66-->')
	outgoingbutton:SetNormalTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Up")
	outgoingbutton:SetPushedTexture("Interface\\AddOns\\WJH\\Textures\\UI-Panel-Button-Down")
	outgoingbutton:SetHighlightTexture("Interface\\AddOns\\WJH\\Textures\\ButtonHilight-Square")
	
	local outgoingfont = outgoingbutton:CreateFontString("WJH_incomingfont","OVERLAY","GameFontNormal")
	outgoingfont:SetJustifyH("LEFT")
	outgoingfont:SetPoint("TOPRIGHT", outgoingbutton, "TOPLEFT", -7, 0)
	outgoingfont:SetText("Out")
	outgoingfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	outgoingfont:Show()
	
	local incomingCheckButton = CreateFrame("CheckButton", "incomingCheckButton", frame, "UICheckButtonTemplate")
	incomingCheckButton:SetScript("OnClick", WJH_incomingCheckButton)
	incomingCheckButton:SetWidth(14)
	incomingCheckButton:SetHeight(14)
	incomingCheckButton:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 17, 10)
	incomingCheckButton:SetChecked(incoming)
	incomingCheckButton.tooltip = "Incoming"
	
	local outgoingCheckButton = CreateFrame("CheckButton", "outgoingCheckButton", frame, "UICheckButtonTemplate")
	outgoingCheckButton:SetScript("OnClick", WJH_outgoingCheckButton)
	outgoingCheckButton:SetWidth(14)
	outgoingCheckButton:SetHeight(14)
	outgoingCheckButton:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -55, 10)
	outgoingCheckButton:SetChecked(outgoing)
	outgoingCheckButton.tooltip = 'Outgoing'
	
	local outgoingmissesbox = CreateFrame("CheckButton","outgoingmissesbox", frame, "UICheckButtonTemplate")
	outgoingmissesbox:SetScript("OnClick", f_outgoingmisses)
	outgoingmissesbox:SetWidth(14)
	outgoingmissesbox:SetHeight(14)
	outgoingmissesbox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 17, 9)
	outgoingmissesbox:Hide()
	outgoingmissesbox:SetChecked(outgoingMisses)
	outgoingmissesbox.tooltip = 'Outgoing Misses'
	
	local outgoingmissesfont = outgoingmissesbox:CreateFontString("outgoingmissesfont","OVERLAY","GameFontNormal")
	outgoingmissesfont:SetJustifyH("LEFT")
	outgoingmissesfont:SetPoint("TOPLEFT", outgoingmissesbox, "TOPRIGHT", 5, 0)
	outgoingmissesfont:SetText("Miss")
	outgoingmissesfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	
	local outgoinghealsbox = CreateFrame("CheckButton", "outgoinghealsbox", frame, "UICheckButtonTemplate")
	outgoinghealsbox:SetScript("OnClick", f_outgoingheals)
	outgoinghealsbox:SetWidth(14)
	outgoinghealsbox:SetHeight(14)
	outgoinghealsbox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 67, 9)
	outgoinghealsbox:Hide()
	outgoinghealsbox:SetChecked(outgoingHeals)
	outgoinghealsbox.tooltip = 'Outgoing Heals'
	
	local outgoinghealsfont = outgoinghealsbox:CreateFontString("outgoinghealsfont","OVERLAY","GameFontNormal")
	outgoinghealsfont:SetJustifyH("LEFT")
	outgoinghealsfont:SetPoint("TOPLEFT", outgoinghealsbox, "TOPRIGHT", 5, 0)
	outgoinghealsfont:SetText("Heals")
	outgoinghealsfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	
	local outgoingdamagebox = CreateFrame("CheckButton", "outgoingdamagebox", frame, "UICheckButtonTemplate")
	outgoingdamagebox:SetScript("OnClick", f_outgoingdamage)
	outgoingdamagebox:SetWidth(14)
	outgoingdamagebox:SetHeight(14)
	outgoingdamagebox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 117, 9)
	outgoingdamagebox:Hide()
	outgoingdamagebox:SetChecked(outgoingDmg)
	outgoingdamagebox.tooltip = 'Outgoing Damage'
	
	local outgoingdamagefont = outgoingdamagebox:CreateFontString("outgoingdamagefont","OVERLAY","GameFontNormal")
	outgoingdamagefont:SetJustifyH("LEFT")
	outgoingdamagefont:SetPoint("TOPLEFT", outgoingdamagebox, "TOPRIGHT", 5, 0)
	outgoingdamagefont:SetText("Dmg")
	outgoingdamagefont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	
	local incomingmissesbox = CreateFrame("CheckButton", "incomingmissesbox", frame, "UICheckButtonTemplate")
	incomingmissesbox:SetScript("OnClick", f_incomingmisses)
	incomingmissesbox:SetWidth(14)
	incomingmissesbox:SetHeight(14)
	incomingmissesbox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 17, 9)
	incomingmissesbox:Hide()
	incomingmissesbox:SetChecked(incomingMisses)
	incomingmissesbox.tooltip = 'Incoming Misses'
	
	local incomingmissesfont = incomingmissesbox:CreateFontString("incomingmissesfont","OVERLAY","GameFontNormal")
	incomingmissesfont:SetJustifyH("LEFT")
	incomingmissesfont:SetPoint("TOPLEFT", incomingmissesbox, "TOPRIGHT", 5, 0)
	incomingmissesfont:SetText("Miss")
	incomingmissesfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	
	local incominghealsbox = CreateFrame("CheckButton", "incominghealsbox", frame, "UICheckButtonTemplate")
	incominghealsbox:SetScript("OnClick", f_incomingheals)
	incominghealsbox:SetWidth(14)
	incominghealsbox:SetHeight(14)
	incominghealsbox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 67, 9)
	incominghealsbox:Hide()
	incominghealsbox:SetChecked(incomingHeals)
	incominghealsbox.tooltip = 'Incoming Heals'
	
	local incominghealsfont = incominghealsbox:CreateFontString("incominghealsfont","OVERLAY","GameFontNormal")
	incominghealsfont:SetJustifyH("LEFT")
	incominghealsfont:SetPoint("TOPLEFT", incominghealsbox, "TOPRIGHT", 5, 0)
	incominghealsfont:SetText("Heals")
	incominghealsfont:SetFont("Fonts\\FRIZQT__.TTF", 9)
	
	local incomingdamagebox = CreateFrame("CheckButton", "incomingdamagebox", frame, "UICheckButtonTemplate")
	incomingdamagebox:SetScript("OnClick", f_incomingdamage)
	incomingdamagebox:SetWidth(14)
	incomingdamagebox:SetHeight(14)
	incomingdamagebox:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 117, 9)
	incomingdamagebox:Hide()
	incomingdamagebox:SetChecked(incomingDmg)
	incomingdamagebox.tooltip = 'Incoming Damage'
	
	local incomingdamagefont = incomingdamagebox:CreateFontString("incomingdamagefont","OVERLAY","GameFontNormal")
	incomingdamagefont:SetJustifyH("LEFT")
	incomingdamagefont:SetPoint("TOPLEFT", incomingdamagebox, "TOPRIGHT", 5, 0)
	incomingdamagefont:SetText("Dmg")
	incomingdamagefont:SetFont("Fonts\\FRIZQT__.TTF", 9)
		
	local statusbg = CreateFrame("Frame",nil,frame)
	statusbg:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",5,5)
	statusbg:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-42,5)
	statusbg:SetHeight(24)
	statusbg:SetBackdrop(PaneBackdrop)
	statusbg:SetBackdropColor(0.1,0.1,0.1)
	statusbg:SetBackdropBorderColor(0.4,0.4,0.4)
	
	-- local statustext = statusbg:CreateFontString(nil,"OVERLAY","GameFontNormal")
	-- statustext:SetPoint("TOPLEFT",statusbg,"TOPLEFT",7,-2)
	-- statustext:SetPoint("BOTTOMRIGHT",statusbg,"BOTTOMRIGHT",-7,2)
	-- statustext:SetHeight(20)
	-- statustext:SetJustifyH("LEFT")
	-- statustext:SetText("")
		
	-- local title = CreateFrame("Frame",nil,frame)
	-- title:EnableMouse()
	frame:SetScript("OnMouseDown",titleOnMouseDown)
	frame:SetScript("OnMouseUp", frameOnMouseUp)
		
		
	-- local titlebg = frame:CreateTexture(nil,"OVERLAY")
	-- titlebg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	-- titlebg:SetTexCoord(0.31,0.67,0,0.63)
	-- titlebg:SetPoint("TOP",frame,"TOP",0,12)
	-- titlebg:SetWidth(100)
	-- titlebg:SetHeight(40)

	-- local titlebg_l = frame:CreateTexture(nil,"OVERLAY")
	-- titlebg_l:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	-- titlebg_l:SetTexCoord(0.21,0.31,0,0.63)
	-- titlebg_l:SetPoint("RIGHT",titlebg,"LEFT",0,0)
	-- titlebg_l:SetWidth(30)
	-- titlebg_l:SetHeight(40)
		
	-- local titlebg_right = frame:CreateTexture(nil,"OVERLAY")
	-- titlebg_right:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	-- titlebg_right:SetTexCoord(0.67,0.77,0,0.63)
	-- titlebg_right:SetPoint("LEFT",titlebg,"RIGHT",0,0)
	-- titlebg_right:SetWidth(30)
	-- titlebg_right:SetHeight(40)
		
	-- title:SetAllPoints(titlebg)			
	-- local titletext = title:CreateFontString(nil,"OVERLAY","GameFontNormal")
	-- titletext:SetPoint("TOP",titlebg,"TOP",0,-14)
		
	local sizer_se = CreateFrame("Frame",nil,frame)
	sizer_se:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,0)
	sizer_se:SetWidth(25)
	sizer_se:SetHeight(25)
	sizer_se:EnableMouse(true)
	sizer_se:SetScript("OnMouseDown",sizerseOnMouseDown)
	sizer_se:SetScript("OnMouseUp", frameOnMouseUp)
	
	-- local line1 = sizer_se:CreateTexture(nil, "BACKGROUND")
	-- line1:SetWidth(14)
	-- line1:SetHeight(14)
	-- line1:SetPoint("BOTTOMRIGHT", -8, 8)
	-- line1:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	-- local x = 0.1 * 14/17
	-- line1:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)
	
	-- local line2 = sizer_se:CreateTexture(nil, "BACKGROUND")
	-- line2:SetWidth(8)
	-- line2:SetHeight(8)
	-- line2:SetPoint("BOTTOMRIGHT", -8, 8)
	-- line2:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	-- local x = 0.1 * 8/17
	-- line2:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

	local sizer_s = CreateFrame("Frame",nil,frame)
	sizer_s:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",-10,0)
	sizer_s:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",0,0)
	sizer_s:SetHeight(10)
	sizer_s:EnableMouse(true)
	sizer_s:SetScript("OnMouseDown",sizersOnMouseDown)
	sizer_s:SetScript("OnMouseUp", frameOnMouseUp)
		
	local sizer_e = CreateFrame("Frame",nil,frame)
	sizer_e:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,10)
	sizer_e:SetPoint("TOPRIGHT",frame,"TOPRIGHT",0,0)
	sizer_e:SetWidth(10)
	sizer_e:EnableMouse(true)
	sizer_e:SetScript("OnMouseDown",sizereOnMouseDown)
	sizer_e:SetScript("OnMouseUp", frameOnMouseUp)
	
	local count = 0
	
	local scrollframechild = CreateFrame('FRAME', nil, scrollframe)
	local ScrollFrame = CreateFrame('SCROLLFRAME', "WJH_ScrollFrame", rightframe)
	ScrollFrame:SetScrollChild(scrollframechild)
	ScrollFrame:SetBackdropColor(0,0,0,0)
	ScrollFrame:SetBackdropBorderColor(0,0,0,0)
	ScrollFrame:SetPoint("TOPRIGHT", rightframe, "TOPRIGHT", -14, -10)
	ScrollFrame:SetPoint("TOPLEFT", rightframe, "TOPLEFT", 10, -10)
	ScrollFrame:SetPoint("BOTTOM", rightframe, "BOTTOM", 0, 15)
	scrollframechild:SetWidth(rightframe:GetWidth()-30)
	scrollframechild:SetHeight(rightframe:GetHeight())
	
	for k = 1, 5 do
		line = CreateFrame("Frame", "WJH_line"..k, scrollframechild)
		line:SetBackdrop(PaneBackdrop)
		line:SetBackdropColor(0.1,0.1,0.1)
		line:SetBackdropBorderColor(0.4,0.4,0.4)
		line:SetHeight(30)
		if count == 0 then
			line:SetPoint('TOPLEFT', scrollframechild, 'TOPLEFT', 2, -3)
			line:SetPoint('TOPRIGHT', scrollframechild, 'TOPRIGHT', 9, -3)
			local font = line:CreateFontString("WJH_font"..k, "FULLSCREEN_DIALOG")
			font:SetFont("Fonts\\FRIZQT__.TTF", 9)
			font:SetWidth(line:GetWidth()-4)
			font:SetPoint("LEFT", line, "LEFT", 5, 0)
			font:SetJustifyH("LEFT")
			table.insert(linetable, line)
			table.insert(fonttable, font)
			count = count +3
			-- font:SetScript("OnHyperlinkClick", function(self, linkData, link, button) DefaultChatFrame:SendMessage(link) end)
			else
			line:SetPoint('TOPLEFT', scrollframechild, 'TOPLEFT', 2, -(24+count))
			line:SetPoint('TOPRIGHT', scrollframechild, 'TOPRIGHT', 9, -(24+count))
			local font = line:CreateFontString("WJH_font"..k, "FULLSCREEN_DIALOG")
			font:SetFont("Fonts\\FRIZQT__.TTF", 9)
			font:SetWidth(line:GetWidth()-2)
			font:SetPoint("CENTER", line, "CENTER", 5, 0)
			-- font:SetPoint("LEFT", line, "LEFT", 5, 0)
			font:SetJustifyH("LEFT")
			table.insert(linetable, line)
			table.insert(fonttable, font)
			count = count + 24
			-- font:SetScript("OnHyperlinkClick", function(self, linkData, link, button) DefaultChatFrame:SendMessage(link) end)
		end
	end
end

function f_incomingmisses()
	if incomingMisses == true then
		incomingMisses = false
	else
		incomingMisses = true
	end
	WJH:Refresh()
end
	
function f_incomingheals()
	if incomingHeals == true then
		incomingHeals = false
	else
		incomingHeals = true
	end
	WJH:Refresh()
end
	
function f_incomingdamage()
	if incomingDmg == true then
		incomingDmg = false
	else
		incomingDmg = true
	end
	WJH:Refresh()
end

function f_outgoingmisses()
	if outgoingMisses == true then
		outgoingMisses = false
	else
		outgoingMisses = true
	end
	WJH:Refresh()
end
	
function f_outgoingheals()
	if outgoingHeals == true then
		outgoingHeals = false
	else
		outgoingHeals = true
	end
	WJH:Refresh()
end
	
function f_outgoingdamage()
	if outgoingDmg == true then
		outgoingDmg = false
	else
		outgoingDmg = true
	end
	WJH:Refresh()
end

function WJH:FontHandling(printstring, eventtype)
	for k,v in pairs(fonttable) do
		if fonttable[k+1] then
			v:SetText(fonttable[k+1]:GetText())
			linetable[k]:SetBackdropColor(linetable[k+1]:GetBackdropColor())
		else
			v:SetText(printstring)
			if eventtype == 'SWING_DAMAGE' or eventtype == 'SPELL_DAMAGE' or eventtype == 'RANGE_DAMAGE' or eventtype == 'SPELL_PERIODIC_DAMAGE' then
				linetable[k]:SetBackdropColor(0.3, 0.1, 0.1)
			elseif eventtype == 'SPELL_HEAL' or eventtype == 'SPELL_PERIODIC_HEAL' then
				linetable[k]:SetBackdropColor(0.1, 0.3, 0.1)
			else
				linetable[k]:SetBackdropColor(0.1, 0.1, 0.1)
			end
		end
	end
end

function WJH:tableInsertions(printstring, event, eventtype, hitter, hitee, misstype, damage, dmgtype, heal)
	if printstring == nil then
		printstring = 0
	end
	if event == nil then
		event = 0
	end
	if eventtype == nil then
		eventtype = 0
	end
	if hitter == nil then
		hitter = 0
	end
	if hitee == nil then
		hitee = 0
	end
	if misstype == nil then
		misstype = 0
	end
	if damage == nil then
		damage = 0
	end
	if dmgtype == nil then
		dmgtype = 0
	end
	table.insert(bigtable, {})
	table.insert(bigtable[#bigtable], printstring)
	table.insert(bigtable[#bigtable], event)  --2
	table.insert(bigtable[#bigtable], eventtype)  --3
	table.insert(bigtable[#bigtable], hitter)  --4
	table.insert(bigtable[#bigtable], hitee)  --5
	table.insert(bigtable[#bigtable], misstype)  --6
	table.insert(bigtable[#bigtable], damage)  --7
	table.insert(bigtable[#bigtable], dmgtype)  --8
	table.insert(bigtable[#bigtable], heal)  --9
end

local function types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
	local dmgtype = nil
	if dmg == 1 then
		dmgtype = 'Physical'
	elseif dmg == 2 then
		dmgtype = 'Holy'
	elseif dmg == 4 then
		dmgtype = 'Fire'
	elseif dmg == 8 then
		dmgtype = 'Nature'
	elseif dmg == 16 then
		dmgtype = 'Frost'	
	elseif dmg == 32 then
		dmgtype = 'Shadow'
	elseif dmg == 64 then
		dmgtype = 'Arcane'
	end
	local misstype = nil
	if miss == 'ABSORB' then
		misstype = 'Absorb'
	elseif miss == 'BLOCK' then
		misstype = 'Block'
	elseif miss == 'DEFLECT' then
		misstype = 'Deflect'
	elseif miss == 'DODGE' then
		misstype = 'Dodge'
	elseif miss == 'EVADE' then
		misstype = 'Evade'
	elseif miss == 'IMMUNE' then
		misstype = 'Immune'
	elseif miss == 'MISS' then
		misstype = 'Miss'
	elseif miss == 'PARRY' then
		misstype = 'Parry'
	elseif miss == 'REFLECT' then
		misstype = 'Reflect'
	elseif miss == 'RESIST' then
		misstype = 'Resist'
	end
	if misstype == "Block" or misstype == "Absorb" then
		printstring = printstring.." |cffff9933"..damage
	end
	if misstype ~= nil then
		printstring = printstring.." |cffCCCCCC".. misstype
	end
	if dmgtype ~= nil and heal == nil then
		printstring = printstring.." |cffCCCCCC"..dmgtype
	end
	WJH:tableInsertions(printstring, event, eventtype, hitter, hitee, misstype, damage, dmgtype, heal)
	if (hitee == UnitName('player') and incoming == true) or (hitter == UnitName('player') and outgoing == true) then
		if ( (eventtype =='SPELL_PERIODIC_HEAL' or eventtype == 'SPELL_HEAL' ) and incomingHeals == true and hitee == playername and hitter ~= playername) or 
			(( eventtype == 'SPELL_DAMAGE' or eventtype == 'SPELL_PERIODIC_DAMAGE' or eventtype == 'RANGE_DAMAGE' or eventtype == "SWING_DAMAGE" ) and incomingDmg == true and hitee == playername) or
			(( eventtype == 'SPELL_MISSED' or eventtype == 'SPELL_PERIODIC_MISSED' or eventtype == 'RANGE_MISSED' or eventtype == "SWING_MISSED" ) and incomingMisses == true and hitee == playername) or
			( (eventtype =='SPELL_PERIODIC_HEAL' or eventtype == 'SPELL_HEAL' ) and outgoingHeals == true and hitter == playername and hitee ~= playername) or 
			(( eventtype == 'SPELL_PERIODIC_HEAL' or eventtype == 'SPELL_HEAL') and (outgoingHeals == true and incomingHeals == true)) or
			(( eventtype == 'SPELL_DAMAGE' or eventtype == 'SPELL_PERIODIC_DAMAGE' or eventtype == 'RANGE_DAMAGE' or eventtype == "SWING_DAMAGE" ) and outgoingDmg == true and hitter == playername) or
			(( eventtype == 'SPELL_MISSED' or eventtype == 'SPELL_PERIODIC_MISSED' or eventtype == 'RANGE_MISSED' or eventtype == "SWING_MISSED" ) and outgoingMisses == true and hitter == playername) then
			table.insert(scrolltable, {})
			table.insert(scrolltable[#scrolltable], printstring)
			table.insert(scrolltable[#scrolltable], event)  --2
			table.insert(scrolltable[#scrolltable], eventtype)  --3
			table.insert(scrolltable[#scrolltable], hitter)  --4
			table.insert(scrolltable[#scrolltable], hitee)  --5
			table.insert(scrolltable[#scrolltable], misstype)  --6
			table.insert(scrolltable[#scrolltable], damage)  --7
			table.insert(scrolltable[#scrolltable], dmgtype)  --8
			table.insert(scrolltable[#scrolltable], heal)  --9
			if mw_count ~= 0 then
				mw_count = 0
				for k,v in pairs(fonttable) do
					v:SetText(nil)
					linetable[k]:SetBackdropColor(0.1, 0.1, 0.1)
				end
				for k,v in pairs(scrolltable) do
					local printstring = v[1]
					local eventtype = v[2]
					WJH:FontHandling(printstring, eventtype)
					-- break
				end
			end
			WJH:FontHandling(printstring, eventtype)
		end
	end
	-- if (hitter == UnitName('player') and outgoing == true) then
		-- if ( (eventtype =='SPELL_PERIODIC_HEAL' or eventtype == 'SPELL_HEAL' ) and outgoingHeals == true and hitter == playername) or 
			-- (( eventtype == 'SPELL_DAMAGE' or eventtype == 'SPELL_PERIODIC_DAMAGE' or eventtype == 'RANGE_DAMAGE' or eventtype == "SWING_DAMAGE" ) and outgoingDmg == true and hitter == playername) or
			-- (( eventtype == 'SPELL_MISSED' or eventtype == 'SPELL_PERIODIC_MISSED' or eventtype == 'RANGE_MISSED' or eventtype == "SWING_MISSED" ) and outgoingMisses == true and hitter == playername) then
			-- table.insert(scrolltable, {})
			-- table.insert(scrolltable[#scrolltable], printstring)
			-- table.insert(scrolltable[#scrolltable], event)  --2
			-- table.insert(scrolltable[#scrolltable], eventtype)  --3
			-- table.insert(scrolltable[#scrolltable], hitter)  --4
			-- table.insert(scrolltable[#scrolltable], hitee)  --5
			-- table.insert(scrolltable[#scrolltable], misstype)  --6
			-- table.insert(scrolltable[#scrolltable], damage)  --7
			-- table.insert(scrolltable[#scrolltable], dmgtype)  --8
			-- table.insert(scrolltable[#scrolltable], heal)  --9
			-- if mw_count ~= 0 then
				-- mw_count = 0
				-- for k,v in pairs(fonttable) do
					-- v:SetText(nil)
					-- linetable[k]:SetBackdropColor(0.1, 0.1, 0.1)
				-- end
				-- for k,v in pairs(scrolltable) do
					-- local printstring = v[1]
					-- local eventtype = v[2]
					-- WJH:FontHandling(printstring, eventtype)
					-- break
				-- end
			-- end
			-- WJH:FontHandling(printstring, eventtype)
		-- end
	-- end
end

-- Called every time our event is thrown
function WJH:COMBAT_LOG_EVENT_UNFILTERED(event, arg1, eventtype, arg3, hitter, arg5, arg6, hitee, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20)
	if (hitee == playername or hitter == playername) and (hitter ~= nil and hitee ~= nil) then -- we only care if we are the one being hit or doing the hitting
		if eventtype == "SWING_DAMAGE" then  -- normal white swing
			local printstring = 0			
			if UnitHealth('player') + arg9 > UnitHealthMax('player') then
				printstring ="|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..arg9
			else	
				printstring ="|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..(UnitHealth('player')+arg9).." - "..arg9
			end
			if arg13 ~= nil then printstring = printstring.." "..arg13.."|cff00FF66 blocked" end
			if arg14 ~= nil then printstring = printstring.." "..arg14.."|cff00FF66 absorbed" end
			local damage = arg9
			local dmg = arg11
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype == "SWING_MISSED" then 
			local printstring = "|cffCCCCCC"..hitter.." |cffFFFFFF".."|cff00FF66 O |cffFFFFFF"..hitee
			local miss = arg9
			local damage = arg10
			-- local dmg = 
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype == "SPELL_MISSED" then
			local printstring = "|cffCCCCCC"..hitter.." |cffFFFFFF".."|cff00FF66 O |cffFFFFFF"..hitee
			local miss = arg12
			local damage = arg13
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype =="SPELL_DAMAGE" then
			local dmg = arg11
			local printstring = 0	
			if UnitHealth('player') + arg12 > UnitHealthMax('player') then
				printstring = "|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..arg12..GetSpellLink(arg9)
			else
				printstring = "|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..(UnitHealth('player')+arg12).." - "..arg12..GetSpellLink(arg9)
			end
			local damage = arg12
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype =="SPELL_PERIODIC_DAMAGE" then
			local dmg = arg11
			local printstring = 0	
			if UnitHealth('player') + arg12 > UnitHealthMax('player') then
				printstring = "|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..arg12..GetSpellLink(arg9).."|cff00FF66 DOT"
			else
				printstring = "|cffCCCCCC"..hitter.. '|cffff9933 --> |cffCCCCCC' ..hitee.. ' |cffff9933'..(UnitHealth('player')+arg12).." - "..arg12..GetSpellLink(arg9).."|cff00FF66 DOT"
			end
			local damage = arg12
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype =="SPELL_HEAL" then
			local heal = arg12
			local printstring = "|cffCCCCCC"..hitter.. '|cff00FF66 --+ |cffCCCCCC' ..hitee.. ' |cff00FF66'..(UnitHealth('player')-arg12).." + "..arg12..GetSpellLink(arg9)
			-- if arg13 ~= nil then
				-- printstring = printstring.." "..arg13.."|cffCCCCCC over"
			-- end
			local dmg = arg11
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
			
		elseif eventtype =="SPELL_PERIODIC_HEAL" then
			local  heal = arg12
			local printstring = "|cffCCCCCC"..hitter.. '|cff00FF66 --+ |cffCCCCCC' ..hitee.. ' |cff00FF66'..(UnitHealth('player')-arg12).." + "..arg12..GetSpellLink(arg9).."|cff00FF66 HOT"
			-- if arg13 ~= nil then
				-- printstring = printstring.." "..arg13.."|cffCCCCCC over"
			-- end
			local dmg = arg11
			types(dmg, miss, printstring, event, eventtype, hitter, hitee, damage, heal)
		end
	end
end

function WJH_OnMouseWheel(self, arg1)
	if mw_count == 0 and arg1 < 0 then 
		return
	end
	mw_count = mw_count + arg1
	-- print(mw_count)
	for k,v in pairs(fonttable) do
		v:SetText(nil)
		linetable[k]:SetBackdropColor(0.1, 0.1, 0.1)
	end
	for k,v in pairs(scrolltable) do
		if k <= #scrolltable - mw_count then
			local printstring = v[1]
			local eventtype = v[3]
			WJH:FontHandling(printstring, eventtype)
		else
			break
		end
	end
end

function WJH:ChatCommand(input)
	if not input or input:trim() == "" then
		WJH_MainFrame:Show()
	elseif input == 'hide' then
		WJH_MainFrame:Hide()
	elseif input == 'lock' then
		WJH_MainFrame:EnableMouse(false)
		lock = true
		DEFAULT_CHAT_FRAME:AddMessage('Locked')
	elseif input == 'unlock' then
		WJH_MainFrame:EnableMouse(true)
		lock = false
		DEFAULT_CHAT_FRAME:AddMessage('Unlocked')
	elseif input == 'help' then
		DEFAULT_CHAT_FRAME:AddMessage('/wjh - Show Main Frame')
		DEFAULT_CHAT_FRAME:AddMessage('/wjh help - Show This Again')
		DEFAULT_CHAT_FRAME:AddMessage('/wjh lock - Lock Main Frame')
		DEFAULT_CHAT_FRAME:AddMessage('/wjh unlock - Unlock Main Frame')
		DEFAULT_CHAT_FRAME:AddMessage('/wjh scale - Set Main Frame Scale (ex. /wjh scale 0.8)')
	elseif string.match(input, '^scale') == 'scale' or string.match(input, '^Scale') == 'Scale' then
		number = string.match(input, '%d+%\.%d+')
		if number == nil then
			number = string.match(input, '%d+')
		end
		if number == nil then
			DEFAULT_CHAT_FRAME:AddMessage('Invalid Scale')
		else
			number = tonumber(number)
			WJH_MainFrame:SetScale(number)
		end
	end	
end

function WJH_incomingCheckButton()
	if incoming == true then
		incoming = false
	else
		incoming = true
	end
	WJH:Refresh()
end

function WJH_outgoingCheckButton()
	if outgoing == true then
		outgoing = false
	else
		outgoing = true
	end
	WJH:Refresh()
end

function WJH:Refresh()
	wipe(scrolltable)
	local a = {}
	for k,v in pairs(bigtable) do
		table.insert(scrolltable, {})
		table.insert(scrolltable[#scrolltable], v[1])
		table.insert(scrolltable[#scrolltable], v[2]) 
		table.insert(scrolltable[#scrolltable], v[3]) 
		table.insert(scrolltable[#scrolltable], v[4]) 
		table.insert(scrolltable[#scrolltable], v[5]) 
		table.insert(scrolltable[#scrolltable], v[6]) 
		table.insert(scrolltable[#scrolltable], v[7]) 
		table.insert(scrolltable[#scrolltable], v[8]) 
		table.insert(scrolltable[#scrolltable], v[9]) 
	end
	for k,v in pairs(scrolltable) do
		if outgoing == false and incoming == false then
			table.insert(a, k)
		elseif incoming == false and v[5] == playername and v[4] ~= playername then
			table.insert(a, k)
		elseif outgoing == false and v[4] == playername and v[5] ~= playername then
			table.insert(a, k)
		end
	end
	local count = 0
	for k,v in pairs(a) do
		table.remove(scrolltable, v-count)
		count=count+1
	end
	wipe(a)
	for k,v in pairs(scrolltable) do
		if incomingMisses == false and v[5] == playername then
			if v[3] == 'SPELL_MISSED' or v[3] == 'RANGED_MISSED' or v[3] == 'SWING_MISSED' or v[3] == 'SPELL_PERIODIC_MISSED' then
				table.insert(a, k)
			end
		end
		if incomingHeals == false and v[5] == playername and v[9] ~= nil then
			table.insert(a, k)
		end
		if incomingDmg == false and v[5] == playername then
			if v[3] == 'SWING_DAMAGE' or v[3] == 'SPELL_DAMAGE' or v[3] == 'RANGE_DAMAGE' or v[3] == 'SPELL_PERIODIC_DAMAGE' then
				table.insert(a, k)
			end
		end
		if outgoingMisses == false and v[4] == playername then
			if v[3] == 'SPELL_MISSED' or v[3] == 'RANGED_MISSED' or v[3] == 'SWING_MISSED' or v[3] == 'SPELL_PERIODIC_MISSED' then
				table.insert(a, k)
			end
		end
		if outgoingHeals == false and v[4] == playername and v[9] ~= nil then
			table.insert(a, k)
		end
		if outgoingDmg == false and v[4] == playername then
			if v[3] == 'SWING_DAMAGE' or v[3] == 'SPELL_DAMAGE' or v[3] == 'RANGE_DAMAGE' or v[3] == 'SPELL_PERIODIC_DAMAGE' then
				table.insert(a, k)
			end
		end
		if outgoingHeals == false and incomingHeals == false and v[9] ~= nil and v[4] == playername and v[5] == playername then
			table.insert(a, k)
		end
	end
	local count = 0
	for k,v in pairs(a) do
		table.remove(scrolltable, v-count)
		count=count+1
	end
			
	mw_count = 0
		for k,v in pairs(fonttable) do
		v:SetText(nil)
		linetable[k]:SetBackdropColor(0.1, 0.1, 0.1)
	end
	for k,v in pairs(scrolltable) do
		local printstring = v[1]
		local eventtype = v[3]
		WJH:FontHandling(printstring, eventtype)
	end
end


	
		